sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=5
left=420
sizeHControl=0
sizeVControl=0
tile=1
caption="Fly Away"
tileSpacing=3
End CompInit
Dim group_da1 as group
group_da1 = MakeComponent("group",form1)
CompInit group_da1
proto="group_da1"
caption="Data Entry"
look=1
sizeHControl=1
sizeVControl=1
tile=1
tileSpacing=3
tileHAlign=2
visible=1
End CompInit
Dim group_da2 as group
group_da2 = MakeComponent("group",group_da1)
CompInit group_da2
proto="group_da2"
caption=""
sizeHControl=1
sizeVControl=1
tile=1
tileLayout=1
tileSpacing=3
tileHAlign=2
visible=1
End CompInit
Dim group_da21 as group
group_da21 = MakeComponent("group",group_da2)
CompInit group_da21
proto="group_da21"
caption="Typ"
sizeHControl=1
sizeVControl=1
tile=1
visible=1
End CompInit
Dim list_typ as list
list_typ = MakeComponent("list",group_da21)
CompInit list_typ
proto="list_typ"
width=100
sizeVControl=1
End CompInit
list_typ.name="list_typ"
list_typ.captions[12]="RC Wing Only"
list_typ.captions[11]="RC Wing Only Arrowed"
list_typ.captions[10]="RC EMF Art"
list_typ.captions[9]="RC MF Speed"
list_typ.captions[8]="RC MF Art"
list_typ.captions[7]="RC MF Common"
list_typ.captions[6]="RC Motor Glider"
list_typ.captions[5]="RC Glider Art"
list_typ.captions[4]="RC Glider Slope"
list_typ.captions[3]="RC Glider Thermic"
list_typ.captions[2]="FF Combustion MF F1C"
list_typ.captions[1]="FF Rubber Band MF F1B"
list_typ.captions[0]="FF Glider F1A"
list_typ.visible=1
list_typ.selectedItem=0
group_da21.name="group_da21"
Dim group_da22 as group
group_da22 = MakeComponent("group",group_da2)
CompInit group_da22
proto="group_da22"
caption="Profile"
sizeHControl=1
sizeVControl=1
tile=1
visible=1
End CompInit
Dim list_profile as list
list_profile = MakeComponent("list",group_da22)
CompInit list_profile
proto="list_profile"
width=96
sizeVControl=1
End CompInit
list_profile.name="list_profile"
list_profile.visible=1
group_da22.name="group_da22"
group_da2.name="group_da2"
Dim group_da3 as group
group_da3 = MakeComponent("group",group_da1)
CompInit group_da3
proto="group_da3"
caption=""
sizeHControl=1
sizeVControl=1
tile=1
tileSpacing=3
tileLayout=1
tileHAlign=2
visible=1
End CompInit
Dim group_da31 as group
group_da31 = MakeComponent("group",group_da3)
CompInit group_da31
proto="group_da31"
caption=""
width=100
sizeVControl=1
tile=1
visible=1
End CompInit
Dim number_spw as number
number_spw = MakeComponent("number",group_da31)
CompInit number_spw
proto="number_spw"
caption="b"
sizeHControl=0
sizeVControl=1
width=50
value=2000
displayFormat=0
increment=10
minimum=1
visible=1
End CompInit
number_spw.name="number_spw"
group_da31.name="group_da31"
Dim group_da32 as group
group_da32 = MakeComponent("group",group_da3)
CompInit group_da32
proto="group_da32"
caption=""
width=100
sizeVControl=1
tile=1
visible=1
End CompInit
Dim number_pti as number
number_pti = MakeComponent("number",group_da32)
CompInit number_pti
proto="number_pti"
caption="t"
value=200
sizeHControl=0
sizeVControl=1
width=40
minimum=1
visible=1
End CompInit
number_pti.name="number_pti"
group_da32.name="group_da32"
Dim group_da33 as group
group_da33 = MakeComponent("group",group_da3)
CompInit group_da33
proto="group_da33"
caption=""
width=100
sizeVControl=1
tile=1
visible=1
End CompInit
Dim number_gew as number
number_gew = MakeComponent("number",group_da33)
CompInit number_gew
proto="number_gew"
caption="m"
sizeHControl=0
sizeVControl=1
value=2000
width=50
increment=10
minimum=1
visible=1
End CompInit
number_gew.name="number_gew"
group_da33.name="group_da33"
group_da3.name="group_da3"
group_da1.name="group_da1"
Dim button_be as button
button_be = MakeComponent("button",form1)
CompInit button_be
proto="button_be"
caption="Calculate"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button_be.name="button_be"
Dim text_error as text
text_error = MakeComponent("text",form1)
CompInit text_error
proto="text_error"
width=330
readOnly=1
End CompInit
text_error.name="text_error"
text_error.visible=1
Dim popupDatei as popup
popupDatei = MakeComponent("popup",form1)
CompInit popupDatei
proto="popupDatei"
caption="File"
left=0
top=0
visible=1
End CompInit
Dim buttonAbout as button
buttonAbout = MakeComponent("button",popupDatei)
CompInit buttonAbout
proto="buttonAbout"
caption="About..."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonAbout.name="buttonAbout"
popupDatei.name="popupDatei"
Dim popupFenster as popup
popupFenster = MakeComponent("popup",form1)
CompInit popupFenster
proto="popupFenster"
caption="Window"
left=0
top=0
visible=1
End CompInit
Dim buttonWPolare as button
buttonWPolare = MakeComponent("button",popupFenster)
CompInit buttonWPolare
proto="buttonWPolare"
caption="Resistance Polare"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonWPolare.name="buttonWPolare"
Dim buttonLegend as button
buttonLegend = MakeComponent("button",popupFenster)
CompInit buttonLegend
proto="buttonLegend"
caption="Legend"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonLegend.name="buttonLegend"
popupFenster.name="popupFenster"
form1.width=352
form1.height=193
form1.name="form1"
Dim dialog_res as dialog
dialog_res = MakeComponent("dialog","app")
CompInit dialog_res
proto="dialog_res"
left=278
top=249
tile=1
caption="Fly Performance"
sizeVControl=1
tileSpacing=3
sizeHControl=1
tileHAlign=2
End CompInit
Dim gadget_res as gadget
gadget_res = MakeComponent("gadget",dialog_res)
CompInit gadget_res
proto="gadget_res"
width=480
height=200
visible=1
End CompInit
Dim database_pdb as database
database_pdb = MakeComponent("database",gadget_res)
CompInit database_pdb
proto="database_pdb"
End CompInit
database_pdb.name="database_pdb"
gadget_res.name="gadget_res"
Dim group9 as group
group9 = MakeComponent("group",dialog_res)
CompInit group9
proto="group9"
caption="group9"
look=2
sizeHControl=2
sizeVControl=1
tile=1
tileLayout=1
tileSpacing=3
tileVAlign=3
tileHAlign=1
visible=1
End CompInit
Dim group10 as group
group10 = MakeComponent("group",group9)
CompInit group10
proto="group10"
caption=""
tile=1
tileSpacing=3
tileHAlign=2
tileVAlign=3
sizeVControl=1
sizeHControl=1
visible=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",group10)
CompInit label1
proto="label1"
caption="E max :"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label1.name="label1"
Dim label2 as label
label2 = MakeComponent("label",group10)
CompInit label2
proto="label2"
caption="e max :"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label2.name="label2"
Dim label3 as label
label3 = MakeComponent("label",group10)
CompInit label3
proto="label3"
caption="vs min :"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label3.name="label3"
Dim label4 as label
label4 = MakeComponent("label",group10)
CompInit label4
proto="label4"
caption="v min :"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label4.name="label4"
group10.name="group10"
Dim group11 as group
group11 = MakeComponent("group",group9)
CompInit group11
proto="group11"
caption=" "
tile=1
tileSpacing=3
tileHAlign=2
tileVAlign=3
sizeVControl=1
sizeHControl=1
visible=1
End CompInit
Dim label5 as label
label5 = MakeComponent("label",group11)
CompInit label5
proto="label5"
caption="label5"
visible=1
End CompInit
label5.name="label5"
Dim label6 as label
label6 = MakeComponent("label",group11)
CompInit label6
proto="label6"
caption="label6"
visible=1
End CompInit
label6.name="label6"
Dim label7 as label
label7 = MakeComponent("label",group11)
CompInit label7
proto="label7"
caption="label7"
visible=1
End CompInit
label7.name="label7"
Dim label8 as label
label8 = MakeComponent("label",group11)
CompInit label8
proto="label8"
caption="label8"
visible=1
End CompInit
label8.name="label8"
group11.name="group11"
Dim group12 as group
group12 = MakeComponent("group",group9)
CompInit group12
proto="group12"
caption=" "
tile=1
tileSpacing=3
tileHAlign=2
tileVAlign=3
sizeVControl=1
sizeHControl=1
visible=1
End CompInit
Dim label9 as label
label9 = MakeComponent("label",group12)
CompInit label9
proto="label9"
caption="m/s"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label9.name="label9"
Dim label10 as label
label10 = MakeComponent("label",group12)
CompInit label10
proto="label10"
caption="m/s"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label10.name="label10"
group12.name="group12"
Dim text_status as text
text_status = MakeComponent("text",group9)
CompInit text_status
proto="text_status"
width=240
height=60
readOnly=1
End CompInit
text_status.name="text_status"
text_status.visible=1
group9.name="group9"
dialog_res.name="dialog_res"
Dim dialogAbout as dialog
dialogAbout = MakeComponent("dialog","app")
CompInit dialogAbout
proto="dialogAbout"
left=298
top=98
tile=1
caption="About..."
sizeHControl=1
sizeVControl=1
End CompInit
Dim gadgetAbout as gadget
gadgetAbout = MakeComponent("gadget",dialogAbout)
CompInit gadgetAbout
proto="gadgetAbout"
width=100
height=60
visible=1
End CompInit
gadgetAbout.name="gadgetAbout"
dialogAbout.name="dialogAbout"
Dim dialogWPolare as dialog
dialogWPolare = MakeComponent("dialog","app")
CompInit dialogWPolare
proto="dialogWPolare"
left=297
top=97
tile=1
caption="Resistance Polare"
sizeHControl=1
sizeVControl=1
End CompInit
Dim gadgetWPolare as gadget
gadgetWPolare = MakeComponent("gadget",dialogWPolare)
CompInit gadgetWPolare
proto="gadgetWPolare"
width=300
height=200
visible=1
End CompInit
gadgetWPolare.name="gadgetWPolare"
dialogWPolare.name="dialogWPolare"
Dim dialogLegend as dialog
dialogLegend = MakeComponent("dialog","app")
CompInit dialogLegend
proto="dialogLegend"
left=193
top=217
tile=1
caption="Legend"
sizeHControl=0
sizeVControl=0
End CompInit
Dim textLegend as text
textLegend = MakeComponent("text",dialogLegend)
CompInit textLegend
proto="textLegend"
width=270
height=145
readOnly=1
End CompInit
textLegend.name="textLegend"
textLegend.AppendString(" b		= Wing Spread		in mm\r")
textLegend.AppendString(" t		= Wing Deep			in mm\r")
textLegend.AppendString(" m		= Weight			in g\r")
textLegend.AppendString("\r")
textLegend.AppendString(" E		= Gliding Value\r")
textLegend.AppendString(" E max	= maximum Gliding Value\r")
textLegend.AppendString("\r")
textLegend.AppendString(" e		= Climbing Value\r")
textLegend.AppendString(" e max	= maximum  Climbing Value\r")
textLegend.AppendString("\r")
textLegend.AppendString(" vs		= Decline Speed	in m/s\r")
textLegend.AppendString(" vs min	= minimum vs")
textLegend.visible=1
dialogLegend.height=181
dialogLegend.width=290
dialogLegend.name="dialogLegend"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

REM Flugleistungsberechnung eines Modellflugzeuges
REM (c) Andreas Bollhalder, YoYu-Productions, 1999
REM Last Revision at 10. Oktober 1999

	REM Variablen
	DIM		i		AS	Integer	REM Zhlervariable
	DIM		j		AS	Integer	REM Zhlervariable

	DIM		ifl		AS	FLOAT		REM Hilfsvariable fr Integer -> FLOAT

	DIM		b		AS	FLOAT		REM Spannweite					m
	DIM		t		AS	FLOAT		REM Profiltiefe					m

	DIM		m		AS	FLOAT		REM Modellmasse					kg
	DIM		SF		AS	FLOAT		REM Flgelflche					m2

	DIM		v		AS	FLOAT		REM Fluggeschwindigkeit			m/s
	DIM		vmin	AS	FLOAT		REM min. Fluggeschwindigkeit	m/s
	DIM		vs		AS	FLOAT		REM Sinkfluggeschwindigkeit		m/s
	DIM		vsmin	AS	FLOAT		REM min. Sinkfluggeschw.		m/s
	DIM		Re		AS	FLOAT		REM Reynoldszahl

	DIM		k		AS	FLOAT		REM k-Faktor (Ellipse = 0, delta < 8 = 0.5
									REM delta gross = 0.1)

	DIM		E		AS	FLOAT		REM Gleitzahl
	DIM		Emax	AS	FLOAT		REM max. Gleitzahl

	DIM		delta	AS	FLOAT		REM Flgelstreckung	
	DIM		eta		AS	FLOAT		REM Steigzahl
	DIM		etamax	AS	FLOAT		REM max. Steigzahl

	DIM		Ca		AS	FLOAT		REM Auftriebsbeiwert
	DIM		Camax	AS	FLOAT		REM max. Auftriebsbeiwert
	DIM		Camin	AS	FLOAT		REM min. Auftriebsbeiwert
	DIM		Cw		AS	FLOAT		REM Widerstandsbeiwert
	DIM		Cwi		AS	FLOAT		REM induzierter Widerstandsbeiwert
	DIM		Cwp		AS	FLOAT		REM Profil Widerstandsbeiwert
	DIM		Cws 	AS	FLOAT		REM schdlicher Widerstandsbeiwert
	DIM		Cwges	AS	FLOAT		REM gesammter Widerstandsbeiwert


	DIM		PName					AS	String		REM Profilname
	DIM		vRe[4]					AS	FLOAT		REM Re Werte der Polaren
	DIM		WPolare[4,20]			AS 	FLOAT		REM Widerstandspolare Re,Cw von Ca 0 bis 1.9

	DIM		EResult[40]			AS	FLOAT		REM Ergebnisspeicher Gleitzahl E
	DIM		etaResult[40]			AS	FLOAT		REM Ergebnisspeicher Steigzahl e
	DIM		vsResult[40]			AS	FLOAT		REM Ergebnisspeicher 
													REM Sinkfluggeschwindigkeit vs

	DIM		dbdbName				AS	string		REM database name
	DIM		dbFieldNames[13]		AS	string		REM database field names
	DIM		vProfile[50]			AS	string		REM names of the profiles
	DIM		aProfile				AS	integer	REM point to the current profile
	DIM		vPolare[20]			AS	float		REM values of the current polare
	DIM		aPolare				AS	integer	REM point to the current polare

	DIM		success				AS	integer	REM hold database return code

	REM Kostanten
	CONST	g	9.81				REM Erdbeschleunigung			m/s2
	CONST	phi	1.225				REM Luftdichte					kg/m3
	CONST	pi	3.1415				REM Kreiszahl PI

	CONST	XOFFSET	30
	CONST	YOFFSET	30
	CONST	YREV		200

	REM Standartwerte laden
	b = 2							REM Spannweite
	t = 0.2						REM Flgeltiefe
	m = 2							REM Masse
	v = 10							REM Fluggeschwindigkeit

	vRe[0] = 60000
	vRe[1] = 100000
	vRe[2] = 200000
	vRe[3] = 400000

	REM Database
	dbdbName = "Eppler Profile"					REM database name
	dbFieldNames[0] = "Profilename"			REM database field names
	dbFieldNames[1] = "WPolare_60k"
	dbFieldNames[2] = "WPolare_100k"
	dbFieldNames[3] = "WPolare_200k"
	dbFieldNames[4] = "WPolare_400k"
	dbFieldNames[5] = "APolare_60k"
	dbFieldNames[6] = "APolare_100k"
	dbFieldNames[7] = "APolare_200k"
	dbFieldNames[8] = "APolare_400k"
	dbFieldNames[9] = "MPolare_60k"
	dbFieldNames[10] = "MPolare_100k"
	dbFieldNames[11] = "MPolare_200k"
	dbFieldNames[12] = "MPolare_400k"

	REM open the database
	success = database_pdb.OpenDatabase(dbdbName, 2)
	
	REM if it fails, show an info message
	IF success <> 0 THEN
		text_error.AppendString("\r Database Eppler Profile in document "+\
				"not found.")
		text_error.AppendString("\r Check out for the database update "+\
				"from NewDeal.")
	ELSE
		text_error.AppendString("Database ready... ")
	END IF

	load_profile_names()
	aProfile = 0
	list_profile.selectedItem = aProfile
	load_profile()
end sub

sub module_goTo(context as string)

end sub

function module_getContext()
	module_getContext = ""
end function

sub module_show()
REM code for making this module appear
	form1.visible=1
end sub

sub module_hide()
REM code for making this module disappear
	form1.visible=0
end sub

sub module_exit()
	success = database_pdb.CloseDatabase()
	IF success <> 0 THEN
		text_error.AppendString("\r Database didn't close.")
	END IF
end sub

sub button_be_pressed(self as button)
REM Berechnungen durchfhren und ausgeben
	DIM		for_s			AS	integer	REM Schleifen Startvariable
	DIM		for_e			AS	integer	REM Schleifen Endvariable

	gadget_res.visible = 0

	REM Flgelflche berechnen
	SF = b * t

	REM Flgelstreckung bestimmen
	delta = (b * b) / SF

	REM Flgelgeometrie bercksichtigen
	k = 3 / delta
	IF k < 0.1 THEN
		k = 0.1
	END IF

	REM minimale Fluggeschwindigkeit bestimmen
	IF Camax > 0 THEN
		vmin = SQR((2 * m * g)/(phi * SF * Camax))
	END IF

	REM Ergebnisspeicher loeschen
	Emax = 0
	etamax = 0
	vsmin = 0
	FOR i = 0 TO 39
		EResult[i] = 0
		etaResult[i] = 0
		vsResult[i] = 0
	NEXT i

	REM Von der minimalen Geschwindigkeit bis 39 m/s in 1m Schritten
	for_s = INT(vmin)
	for_e = 39

	IF vmin > 0 THEN

		FOR i = for_s TO for_e
			v = i

			REM Auftriebswert bestimmen
			Ca = (m * g)/((phi / 2) * v * v * SF)

			REM Reynoldszahl bestimmen, unterer und oberer Wert
			Re = v * t * 70000

			REM calculate Cwp
			Cwp = get_cwp_for_ca(Ca, Re)

			IF Cwp <> 0 THEN
				REM Induzierter Widerstandsbeiwert bestimmen
				Cwi = ((Ca * Ca) / (pi * delta)) * (1 + k)

				REM Gesammt Widerstandsbeiwert bestimmen 
				Cwges = Cwp + Cwi + Cws

				REM Strwiderstand
				list_typ_changed(list_typ,0)

				REM Gleitzahl bestimmen
				EResult[i] = Ca / Cwges

				REM Steigzahl bestimmen
				etaResult[i] = (SQR(Ca * Ca * Ca)) / Cwges

				REM Sinkfluggeschwindigkeit bestimmen
				vsResult[i] = SQR((2 * m *g) / (phi * SF * Ca)) * (Cwges / Ca)
			END IF	
		NEXT i

		REM maximale Gleit- und Steigzahl bestimmen
		REM minimale Sinkfluggeschwindigkeit bestimmen
		FOR i = 0 TO 38
			IF EResult[i + 1] > EResult[i] THEN
				Emax = EResult[i + 1]
			END IF
			IF etaResult[i + 1] > etaResult[i] THEN
				etamax = etaResult[i + 1]
			END IF
			IF vsmin = 0 OR (vsResult[i] < vsmin AND vsResult[i] <> 0) THEN
				vsmin = vsResult[i]
			END IF
		NEXT i
	END IF
	
	dialog_res.visible = 1
	gadget_res.visible = 1
	
end sub

sub gadget_res_draw(self as gadget)
REM draws the graphs
	DIM		x1		AS	Integer	REM Koordinaten Start/Ende
	DIM		x2		AS	Integer
	DIM		y1		AS	Integer	REM Koordinaten Start/Ende
	DIM		y2		AS	Integer

	gadget_res.visible = 1									rem Gadget sichtbar machen
	gadget_res.DrawRect(0,0,479,199,WHITE)				rem Hintergrund zeichnen
	gadget_res.DrawHLine(0,479,0,BLACK)					rem Rahmen zeichnen
	gadget_res.DrawVLine(0,479,0,BLACK)
	gadget_res.DrawHLine(0,479,199,DARK_GRAY)
	gadget_res.DrawVLine(0,199,479,DARK_GRAY)

	rem Horizontale Linien zeichnen
	FOR i = 0 TO 15
		gadget_res.DrawHLine(28,444,YREV - 30 -10*i,BLACK)
	NEXT i

	rem Vertikale Linien zeichnen
	FOR i = 0 TO 41
		gadget_res.DrawVLine(172,15,XOFFSET+10*i,BLACK)
	NEXT i

	rem x-Achsen Beschriftung
	FOR i = 0 TO 8
		gadget_res.DrawText(STR(i*5),28+10*i*5,174,BLACK,".",10,0)
	NEXT i
	gadget_res.DrawText("v [m/s]",28,186,BLACK,".",10,0)

	rem y-Achsen Beschriftung links
	FOR i = 0 TO 3
		gadget_res.DrawText(STR(i*10),5,165-10*i*5,BLACK,".",10,0)
	NEXT i
	gadget_res.DrawText("E",10,30,DARK_BLUE,".",10,0)
	gadget_res.DrawText("e",10,40,DARK_RED,".",10,0)

	rem y-Achsen Beschriftung rechts
	FOR i = 0 TO 3
		gadget_res.DrawText(STR(i*5),450,165-10*i*5,BLACK,".",10,0)
	NEXT i
	gadget_res.DrawText("vs",450,30,DARK_GREEN,".",10,0)

	rem Flugleistungen zeichnen
	FOR i = 1 TO 38
		x1 = i * 10 + 30
		x2 = i * 10 + 40
		rem Ergebnisse Gleitzahl zeichnen
		IF ((EResult[i] + EResult[i+1] > 0) AND (EResult[i+1] <= 30)) THEN
			y1 = INT(EResult[i] * 5 + YOFFSET)
			y2 = INT(EResult[i+1] * 5 + YOFFSET)
			gadget_res.DrawLine(x1,YREV - y1,x2,YREV - y2,DARK_BLUE)
		END IF
		rem Ergebnisse Steigzahl zeichnen
		IF ((etaResult[i] + etaResult[i+1] > 0) AND (etaResult[i+1] <= 30)) THEN
			y1 = INT(etaResult[i] * 5 + YOFFSET)
			y2 = INT(etaResult[i+1] * 5 + YOFFSET)
			gadget_res.DrawLine(x1,YREV - y1,x2,YREV - y2,DARK_RED)
		END IF
		rem Ergebnisse Sinkgeschwindigkeit zeichnen
		IF ((vsResult[i] + vsResult[i+1] > 0) AND (vsResult[i+1] <= 15)) THEN
			y1 = INT(vsResult[i] * 10 + YOFFSET)
			y2 = INT(vsResult[i+1] * 10 + YOFFSET)
			gadget_res.DrawLine(x1,YREV - y1,x2,YREV - y2,DARK_GREEN)
		END IF
	NEXT i
	label5.caption = STR(Emax)
	label6.caption = STR(etamax)
	label7.caption = STR(vsmin)
	label8.caption = STR(vmin)
end sub

sub list_typ_changed(self as list, index as integer)
REM Schdlicher Widerstandsbeiwert bestimmen
	SELECT CASE list_typ.selectedItem
		CASE 0
			Cws = 0.01											rem FF SFZ F1A
		CASE 1
			Cws = 0.01											rem FF Gummi MFZ F1B
		CASE 2
			Cws = 0.01											rem FF Verbrenner MFZ F1C
		CASE 3
			Cws = 0.009										rem RC SFZ Thermik
		CASE 4
			Cws = 0.009										rem RC SFZ Hangflug
		CASE 5
			Cws = 0.009										rem RC SFZ Kunstflug
		CASE 6
			Cws = 0.07											rem RC Motor SFZ
		CASE 7
			Cws = 0.02											rem RC MFZ Allgemein
		CASE 8
			Cws = 0.015										rem RC MFZ Kunstflug
		CASE 9
			Cws = 0.015										rem RC MFZ Geschwindigkeit
		CASE 10
			Cws = 0.015										rem RC E-MFZ Kunstflug
		CASE 11
			Cws = 0.004										rem RC Nurfluegel gepfeilt
		CASE 12
			Cws = 0.004										rem RC Nurfluegel ungepfeilt
	END SELECT
end sub

sub number_pti_changed(self as number, value as integer)
	t = number_pti.value
	t = t / 1000
end sub

sub number_spw_changed(self as number, value as integer)
 	b = number_spw.value
	b = b / 1000
end sub

sub number_gew_changed(self as number, value as integer)
	m = number_gew.value
	m = m / 1000
end sub

sub load_profile_names()
REM load the profile names from the database and stores them in vProfile[50]

	REM there can be at time 50 profile in the database
	FOR i = 0 TO 49

		REM check every 20th record from 0 and get the profile name
		success = database_pdb.GetRecord(i * 20, 0)
		IF success = 0 THEN
			vProfile[i] = database_pdb.GetField(dbFieldNames[0])
			list_profile.captions[i] = vProfile[i]
		ELSE
			vProfile[i] = ""
		END IF
	NEXT i
end sub

sub load_profile()
REM load the data of a profile
	DIM		o				AS		integer		REM offset of the profile

	Camin = 1										REM minimaler Auftriebswert setzen
	Camax = 0										REM maximaler Auftriebswert	zurcksetzen
	o = aProfile * 20							REM Profiloffset berechnen
	FOR i = 1 TO 19
		ifl = i									REM float Hilfsvariable
		success = database_pdb.GetRecord(o + i, 0)
		IF success <> 0 THEN
			text_error.AppendString("\r Couldn't get the record " + STR(i) +".")
		ELSE
			WPolare[0,i] = database_pdb.GetField(dbFieldNames[1])
			IF WPolare[0,i] > 0 THEN
				Camax = ifl / 10
			END IF
			IF WPolare[0,i] <> 0 AND Camin > (ifl / 10) THEN
				Camin = ifl / 10
			END IF
			WPolare[1,i] = database_pdb.GetField(dbFieldNames[2])
			IF WPolare[1,i] > 0 THEN
				Camax = ifl / 10
			END IF
			IF WPolare[1,i] <> 0 AND Camin > (ifl / 10) THEN
				Camin = ifl / 10
			END IF
			WPolare[2,i] = database_pdb.GetField(dbFieldNames[3])
			IF WPolare[2,i] > 0 THEN
				Camax = ifl / 10
			END IF
			IF WPolare[2,i] <> 0 AND Camin > (ifl / 10) THEN
				Camin = ifl / 10
			END IF
			WPolare[3,i] = database_pdb.GetField(dbFieldNames[4])
			IF WPolare[3,i] > 0 THEN
				Camax = ifl / 10
			END IF
			IF WPolare[3,i] <> 0 AND Camin > (ifl / 10) THEN
				Camin = ifl / 10
			END IF
		END IF
	NEXT i
end sub

sub list_profile_changed(self as list, index as integer)
REM update aProfile and load the new profile from the DB
	aProfile = self.selectedItem
	load_profile()
	gadgetWPolare_draw(gadgetWPolare)
end sub

function get_cwp_for_ca(ca_local AS float, re_local AS float) AS float
REM calculate the interpolerated value for a Ca and Re value

	DIM		Ca_low			AS	float		REM unterer Ca Wert
	DIM		Ca_high		AS	float		REM oberer Ca Wert
	DIM		Cwp_low		AS	float		REM unterer Widerstandsbeiwert
	DIM		Cwp_high		AS	float		REM oberer Widerstandsbeiwert

	DIM		Cwp_left		AS	float		REM unterer Profilwiderstand
	DIM		Cwp_right		AS	float		REM oberer Profilwiderstand

	DIM		Re_low			AS	float		REM untere Re-Zahl
	DIM		Re_high		AS	float		REM obere Re-Zahl
	DIM		Re_low_int		AS	integer	REM Index in WPolare
	DIM		Re_high_int	AS	integer	REM Index in WPolare
	DIM		ipf				AS	float		REM Interpolerationsfaktor

	IF (ca_local > 0) AND (ca_local < 2) THEN
		FOR j = 0 TO 3
			IF Re >= vRe[j] THEN
				Re_high_int = j + 1
				Re_low_int = j
			END IF
			IF Re >= vRe[3] THEN
				Re_high_int = 3
				Re_low_int = 2
			END IF
			IF Re <= vRe[0] THEN
				Re_high_int = 1
				Re_low_int = 0
			END IF
		NEXT j

		ipf = (Re - vRe[Re_low_int]) / (vRe[Re_high_int] - vRe[Re_low_int])
		Cwp_high = WPolare[Re_high_int,INT(Ca * 10)]
		Cwp_low = WPolare[Re_low_int,INT(Ca * 10)]
	ELSE
		get_cwp_for_ca = 0
	END IF

	IF Cwp_high = 0 OR Cwp_low = 0 THEN
		get_cwp_for_ca = 0
	ELSE
		get_cwp_for_ca = (Cwp_high - Cwp_low) * ipf + Cwp_low	
rem		get_cwp_for_ca = (Cwp_high - Cwp_low) * ipf + Cwp_high
	END IF
end function

sub buttonAbout_pressed(self as button)
	dialogAbout.visible = 1
end sub

sub buttonWPolare_pressed(self as button)
	dialogWPolare.visible = 1
end sub

sub gadgetAbout_draw(self as gadget)
	gadgetAbout.visible = 1
	gadgetAbout.DrawRect(0,0,99,59,WHITE)						rem Hintergrund zeichnen
	gadgetAbout.DrawHLine(0,99,0,BLACK)						rem Rahmen zeichnen
	gadgetAbout.DrawVLine(0,59,0,BLACK)
	gadgetAbout.DrawHLine(0,99,59,DARK_GRAY)
	gadgetAbout.DrawVLine(0,59,99,DARK_GRAY)
	gadgetAbout.DrawText("YoYu",25,2,DARK_GREEN,".",20,0)	rem Infotext ausgeben
	gadgetAbout.DrawText("Productions",15,30,DARK_GREEN,".",10,0)
	gadgetAbout.DrawText("1999 by Bolle",11,45,DARK_GREEN,".",10,0)
end sub

sub gadgetWPolare_draw(self as gadget)
REM Zeichnet die Widerstandspolare

	DIM		x1	AS	integer
	DIM		x2	AS	integer

	gadgetWPolare.visible = 1								rem Zeichenbereich anzeigen
	gadgetWPolare.DrawRect(0,0,299,199,WHITE)			rem Hintergrund zeichnen
	gadgetWPolare.DrawHLine(0,299,0,BLACK)				rem Rahmen zeichnen
	gadgetWPolare.DrawVLine(0,199,0,BLACK)
	gadgetWPolare.DrawHLine(0,299,199,DARK_GRAY)
	gadgetWPolare.DrawVLine(0,199,299,DARK_GRAY)
	FOR i = 0 TO 15											rem Horizontale Linien zeichnen
		gadgetWPolare.DrawHLine(28,284,170-10*i,BLACK)
	NEXT i
	FOR i = 0 TO 25											rem Vertikale Linien zeichnen
		gadgetWPolare.DrawVLine(172,15,30+10*i,BLACK)
	NEXT i
	FOR i = 0 TO 5											rem x-Achsen Beschriftung
		gadgetWPolare.DrawText(STR(i*5),28+10*i*5,174,BLACK,".",10,0)
	NEXT i
	gadgetWPolare.DrawText("Cw [10E3]",28,186,BLACK,".",10,0)
	FOR i = 0 TO 3											rem y-Achsen Beschriftung
		gadgetWPolare.DrawText(STR(i*0.5),2,165-10*i*5,BLACK,".",10,0)
	NEXT i
	gadgetWPolare.DrawText("Ca",2,30,BLACK,".",10,0)
	gadgetWPolare.DrawText(PName,200,2,DARK_GREEN,".",10,0)

	rem Widerstandspolare zeichnen
	FOR i = 0 TO 3
		FOR j = 0 TO 15
			x1 = INT(WPolare[i,j]*10000)
			x2 = INT(WPolare[i,(j+1)]*10000)
			IF x1 > 0 AND x2 > 0 THEN
				gadgetWPolare.DrawLine(x1+30, 170-10*j, x2+30, 170-10*(j+1),DARK_BLUE)
			END IF
		NEXT j
	NEXT i
end sub

sub buttonLegend_pressed(self as button)
	dialogLegend.visible = 1
end sub

