sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form_pdb as form
form_pdb = MakeComponent("form","app")
CompInit form_pdb
proto="form_pdb"
top=0
left=403
tileVAlign=2
tileLayout=1
caption="Profile Database"
tileSpacing=5
sizeHControl=1
sizeVControl=1
End CompInit
Dim group_profile as group
group_profile = MakeComponent("group",form_pdb)
CompInit group_profile
proto="group_profile"
caption="Profile"
look=1
tile=1
tileSpacing=5
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim entry_profile as entry
entry_profile = MakeComponent("entry",group_profile)
CompInit entry_profile
proto="entry_profile"
visible=1
End CompInit
entry_profile.name="entry_profile"
Dim list_profile as list
list_profile = MakeComponent("list",group_profile)
CompInit list_profile
proto="list_profile"
width=118
height=13
End CompInit
list_profile.name="list_profile"
list_profile.visible=1
Dim group2 as group
group2 = MakeComponent("group",group_profile)
CompInit group2
proto="group2"
caption="group2"
look=2
tile=1
tileLayout=1
tileSpacing=5
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim button_add_profile as button
button_add_profile = MakeComponent("button",group2)
CompInit button_add_profile
proto="button_add_profile"
caption="Add"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button_add_profile.name="button_add_profile"
Dim button_remove_profile as button
button_remove_profile = MakeComponent("button",group2)
CompInit button_remove_profile
proto="button_remove_profile"
caption="Remove"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button_remove_profile.name="button_remove_profile"
group2.name="group2"
Dim text_error as text
text_error = MakeComponent("text",group_profile)
CompInit text_error
proto="text_error"
width=160
height=140
End CompInit
text_error.name="text_error"
text_error.visible=1
group_profile.name="group_profile"
Dim group_polare as group
group_polare = MakeComponent("group",form_pdb)
CompInit group_polare
proto="group_polare"
caption="Polare"
look=1
sizeHControl=3
sizeVControl=1
tile=1
tileSpacing=5
visible=1
End CompInit
Dim entry_polare as entry
entry_polare = MakeComponent("entry",group_polare)
CompInit entry_polare
proto="entry_polare"
visible=1
End CompInit
entry_polare.name="entry_polare"
Dim list_polare as list
list_polare = MakeComponent("list",group_polare)
CompInit list_polare
proto="list_polare"
width=118
height=13
End CompInit
list_polare.name="list_polare"
list_polare.visible=1
Dim button_save_polare as button
button_save_polare = MakeComponent("button",group_polare)
CompInit button_save_polare
proto="button_save_polare"
caption="Save"
visible=1
End CompInit
button_save_polare.name="button_save_polare"
Dim table_polare as table
table_polare = MakeComponent("table",group_polare)
CompInit table_polare
proto="table_polare"
width=160
height=142
numRows=10
numColumns=4
look=1
selectionType=1
End CompInit
table_polare.name="table_polare"
table_polare.rowHeights[9]=14
table_polare.rowHeights[8]=14
table_polare.rowHeights[7]=14
table_polare.rowHeights[6]=14
table_polare.rowHeights[5]=14
table_polare.rowHeights[4]=14
table_polare.rowHeights[3]=14
table_polare.rowHeights[2]=14
table_polare.rowHeights[1]=14
table_polare.rowHeights[0]=14
table_polare.columnWidths[3]=50
table_polare.columnWidths[2]=30
table_polare.columnWidths[1]=50
table_polare.columnWidths[0]=30
table_polare.visible=1
Dim database_pdb as database
database_pdb = MakeComponent("database",group_polare)
CompInit database_pdb
proto="database_pdb"
End CompInit
database_pdb.name="database_pdb"
group_polare.name="group_polare"
form_pdb.name="form_pdb"
form_pdb.height=268
form_pdb.width=373
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

	DIM		dbdbName				AS	string		REM database name
	DIM		dbFieldNames[13]		AS	string		REM database field names
	DIM		vProfile[50]			AS	string		REM names of the profiles
	DIM		aProfile				AS	integer	REM point to the current profile
	DIM		vPolare[20]			AS	float		REM values of the current polare
	DIM		aPolare				AS	integer	REM point to the current polare
	DIM		vField					AS	float		REM value of the current field
	DIM		aField					AS	integer	REM point to the current field

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter

	dbdbName = "Eppler Profile"					REM database name
	dbFieldNames[0] = "Profilename"			REM database field names
	dbFieldNames[1] = "WPolare_60k"
	dbFieldNames[2] = "WPolare_100k"
	dbFieldNames[3] = "WPolare_200k"
	dbFieldNames[4] = "WPolare_400k"
	dbFieldNames[5] = "APolare_60k"
	dbFieldNames[6] = "APolare_100k"
	dbFieldNames[7] = "APolare_200k"
	dbFieldNames[8] = "APolare_400k"
	dbFieldNames[9] = "MPolare_60k"
	dbFieldNames[10] = "MPolare_100k"
	dbFieldNames[11] = "MPolare_200k"
	dbFieldNames[12] = "MPolare_400k"

	REM open the database
	success = database_pdb.OpenDatabase(dbdbName, 2)
	
	REM if it fails, show an info message and create a new database
	IF success <> 0 THEN
		text_error.AppendString("\r Database not found, try to create a new one...")
		success = database_pdb.CreateDatabase(dbdbName, 0, 0, "", "", 0, 0)
		database_pdb.AddField(dbFieldNames[0], "string", 0)
		FOR i = 1 TO 12
			database_pdb.AddField(dbFieldNames[i], "float", 0)
		NEXT i

		REM if the creation fails, show an error message
		IF success <> 0 THEN
			text_error.AppendString("\r Couldn't create database and fields." +\
				"\r Check out for the database update from NewDeal.")
		ELSE
			text_error.AppendString("\r Database and fields are created.")
		END IF
	END IF

	REM load the currently stored profiles
	load_profile_names()
	aProfile = 0
	list_profile.selectedItem = aProfile

	REM make the polare list
	FOR i = 0 TO 11
		list_polare.captions[i] = dbFieldNames[i+1]
	NEXT i
	REM load the first polare
	load_polare(dbFieldNames[1])
	aPolare = 0
	list_polare.selectedItem = aPolare

	aField = 0
	text_error.AppendString("\r Database is ready...")
end sub

sub module_goTo(context as string)

end sub

function module_getContext()
	module_getContext = ""
end function

sub module_show()
REM code for making this module appear
	form_pdb.visible=1
end sub

sub module_hide()
REM code for making this module disappear
	form_pdb.visible=0
end sub

sub module_exit()
REM close the database and shows an error message if it fails
	success = database_pdb.CloseDatabase()
	IF success <> 0 THEN
		text_error.AppendString("\r Database didn't close.")
	END IF
end sub

sub button_add_profile_pressed(self as button)
REM create the records for the profile at the end of the database 
REM and stores the profile name in the first record

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter
	DIM		profile_name			AS	string		REM hold the profile name
	
	profile_name = entry_profile.text			REM save the profile name
	
	REM empty profile name are not allowed
	IF LEN(profile_name) > 0 AND list_profile.numItems < 50 THEN

		REM write 20 new records the profile polares
		FOR i = 0 TO 19
		
			REM if the creation fails, show an error message
			success = database_pdb.NewRecord()
			IF success <> 0 THEN
				text_error.AppendString("\r Couldn't create record " + STR(i) +\
											" for " + profile_name + ".")
			ELSE

				REM write the profile name in the first record
				IF i = 0 THEN
					success = database_pdb.PutField(dbFieldNames[0], profile_name)
					IF success <> 0 THEN
						text_error.AppendString("\r Couldn't write profile name " +\
													profile_name + ".")
					END IF
				END IF

				REM commit the changes to make it saved
				success = database_pdb.PutRecord()
				IF success <> 0 THEN
					text_error.AppendString("\r Record " + STR(i) + " from " + profile_name +\
												" didn't get saved.")
				END IF
				
			END IF
		NEXT i

		IF success = 0 THEN						REM update system
			aProfile = list_profile.numItems
			vProfile[aProfile] = profile_name
			list_profile.captions[aProfile] = profile_name
			list_profile.selectedItem = aProfile
		END IF

	END IF
end sub

sub button_remove_profile_pressed(self as button)
REM removes the records for the selected profile from the database

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter

	REM delete 20 times the record at the startposition of the profile
	FOR i = 0 TO 19
		success = database_pdb.GetRecord(aProfile * 20, 0)
		IF success <> 0 THEN
			text_error.AppendString("\r Couldn't get the record " + STR(i) +\
										" from " + vProfile[aPolare] + ".")
		ELSE
			success = database_pdb.DeleteRecord()
			IF success <> 0 THEN
				text_error.AppendString("\r Couldn't delete record " + STR(i) +\
											" from " + vProfile[aPolare] + ".")
			END IF
		END IF
	NEXT i

	IF success = 0 THEN						REM update system
		list_profile.Delete(aProfile)		REM remove the profile from the list
		vProfile[aProfile] = ""				REM reset value of the profilname
		aProfile = 0
		list_profile.selectedItem = aProfile
		list_polare_changed(list_polare, 0)
	END IF
end sub

sub load_profile_names()
REM load the profile names from the database and stores them in vProfile[50]

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter

	REM there can be at time 50 profile in the database
	FOR i = 0 TO 49

		REM check every 20th record from 0 and get the profile name
		success = database_pdb.GetRecord(i * 20, 0)
		IF success = 0 THEN
			vProfile[i] = database_pdb.GetField(dbFieldNames[0])
			list_profile.captions[i] = vProfile[i]
		ELSE
			vProfile[i] = ""
		END IF
	NEXT i
end sub

sub load_polare(field_name as string)
REM load a polare from the database and stores it in vPolare[20]

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter
	DIM		o						AS	integer	REM offset of the profile

	o = aProfile * 20							REM gives the offset of the current profile
	FOR i = 0 TO 19								REM read the 20 records from the database
		success = database_pdb.GetRecord(o + i, 0)
		IF success <> 0 THEN
			text_error.AppendString("\r Couldn't get the record " + STR(i) + " .")
		ELSE
			vPolare[i] = database_pdb.GetField(field_name)
		END IF
	NEXT i
end sub

sub save_polare(field_name as string)
REM saves a polare to the database from vPolare[20]

	DIM		success				AS	integer	REM hold database return code
	DIM		i						AS	integer	REM counter
	DIM		o						AS	integer	REM offset of the profile
	
	o = aProfile * 20							REM gives the offset of the current profile
	FOR i = 0 TO 19								REM write the 20 records to the database
		success = database_pdb.GetRecord(o + i, 0)
		IF success <> 0 THEN
			text_error.AppendString("\r Couldn't get the record " + STR(i) + ".")
		ELSE
			success = database_pdb.PutField(field_name,vPolare[i])
			IF success <> 0 THEN
				text_error.AppendString("\r Field " + field_name + " isn't replaced.")
			END IF
			success = database_pdb.PutRecord()
			IF success <> 0 THEN
				text_error.AppendString("\r Record " + STR(i) + " didn't get saved.")
			END IF
		END IF
	NEXT i
end sub

sub list_profile_changed(self as list, index as integer)
REM load the first polare of the selected profile
REM this will initialize aField, aPolare and update the table
	aProfile = self.selectedItem
	list_polare.selectedItem = 0
	
	REM force update if selectedItem is always 0
	list_polare_changed(list_polare, 0)
end sub

sub list_polare_changed(self as list, index as integer)
REM load the selected polare and update the table
	aField = 0
	aPolare = self.selectedItem
	load_polare(dbFieldNames[aPolare+1])
	table_polare_draw(table_polare)
end sub

sub table_polare_draw(self as table)
REM draw the tables values and cursor

	DIM		i				AS	integer			rem counter
	DIM		c0				AS	integer			rem column 0
	DIM		c1				AS	integer			rem column 1
	DIM		c2				AS	integer			rem column 2
	DIM		c3				AS	integer			rem column 3
	DIM		cn				AS	integer			rem column number
	DIM		rn				AS	integer			rem row number

	table_polare.Update(0,0,3,9)				rem redraw (clear) table

	IF aField < 10 THEN							rem table cursor in the left or right column
		cn = 1
	ELSE
		cn = 3
	END IF
	rn = (aField MOD 10)
	table_polare.SetSelection(cn, rn, cn, rn)

	c0 = table_polare.GetXPosAt(0)				rem get column coordinates
	c1 = table_polare.GetXPosAt(1)
	c2 = table_polare.GetXPosAt(2)
	c3 = table_polare.GetXPosAt(3)
	FOR i = 0 TO 9
		rem get row coordinate
		rn = table_polare.GetYPosAt(i)
		rem write first column of counter
		table_polare.DrawText("0."+STR(i MOD 10), c0+1, rn+1, BLACK, ".", 10 ,0)
		rem write first column of values
		table_polare.DrawText(STR(vPolare[i]), c1+1, rn+1, BLACK, ".", 10, 0)
		rem write second column of counter
		table_polare.DrawText("1."+STR(i MOD 10), c2+1, rn+1, BLACK, ".", 10 ,0)
		rem write second column of values
		table_polare.DrawText(STR(vPolare[i+10]), c3+1, rn+1, BLACK, ".", 10, 0)
	NEXT i
end sub

sub entry_polare_entered(self as entry)
REM check for valid value an update the table

	DIM		polare_value		AS	string		rem hold the entered value

	polare_value = entry_polare.text		rem save the text entry
	IF LEN(polare_value) > 0 THEN
		vPolare[aField] = VAL(polare_value)
		entry_polare.text = ""
	END IF
	aField = aField + 1						rem increase the cursor by 1
	IF aField > 19 THEN
		aField = 0
	END IF
	table_polare_draw(table_polare)
end sub

sub button_save_polare_pressed(self as button)
REM load a polare from the database
	save_polare(dbFieldNames[aPolare+1])
	aField = 0
	table_polare_draw(table_polare)
end sub

